//+------------------------------------------------------------------+
//| 11:03 AM 6/26/2020                           Countdown Timer.mq4 |
//|                          Copyright  2019-20, WHRoeder@yahoo.com |
//|                                        mailto:WHRoeder@yahoo.com |
//+------------------------------------------------------------------+
#property   copyright   "Copyright  2019-20, WHRoeder@yahoo.com"
#property   link        "mailto:WHRoeder@yahoo.com"
#property   version     "1.02"
#property   strict
#include    <common_utilities.mqh>     // alert_id, MathNearest, Font, gsTicker
//+------------------------------------------------------------------+
//| Specific code                                                    |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 0

//--- input parameters
input int               dispWindow     = 0;
input ENUM_BASE_CORNER  corner         = CORNER_LEFT_LOWER;
input Font              selectedFont   = eFONT_TIMES_NEW_ROMAN_BOLD;
input int               textSize       = 16;
input color             fntcolor       = clrYellow;
input int               XDistance      = 15;
input int               YDistance      = 15;
input bool              Beep           = true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit(){
//--- indicator buffers mapping
   #define TIMER "BarTimer"
   ObjectCreate(TIMER, OBJ_LABEL, dispWindow, 0, 0);
   ObjectSet(TIMER, OBJPROP_CORNER, corner);
   ObjectSet(TIMER, OBJPROP_XDISTANCE, XDistance);
   ObjectSet(TIMER, OBJPROP_YDISTANCE, YDistance);
   ObjectSetInteger(dispWindow, TIMER, OBJPROP_SELECTABLE, false);
//---
   return INIT_SUCCEEDED;
}
void OnDeinit(const int reason){ ObjectDelete(TIMER); }
//+------------------------------------------------------------------+
#define  HR2400   PeriodSeconds(PERIOD_D1)
int                     gLocalToServer = HR2400;
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]){
   if(!gsTicker.enable() ) return prev_calculated;
   static datetime time0;
   if(gLocalToServer == HR2400) time0 = Time[0];   // First tick, suppress alert
   gLocalToServer = (int)MathNearest(TimeCurrent() - TimeLocal(), 1800);
   if(time0 != Time[0]){   time0 = Time[0];  if(Beep) PlaySound("Alert2.wav"); }
   return rates_total;
}
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer(){
   if(gLocalToServer == HR2400) return;   // No first tick, no Time[0]

   datetime servertime  = TimeLocal() + gLocalToServer;
   int      remaining   = int(Time[0] + PeriodSeconds() - servertime);
   int      seconds     = remaining % HR2400;
   int      days        = (remaining - seconds)/HR2400;
   string   display     = (days > 0 ? string(days)+"-" : "")
                        + TimeToString(remaining, TIME_SECONDS);
   ObjectSetText(TIMER, display, textSize, as_string(selectedFont), fntcolor);
}
//+------------------------------------------------------------------+